package com.ibm.hpt.gateway;

/**
 * DISCLAIMER: 
 * The following [enclosed] code is sample code created by IBM 
 * Corporation.  This sample code is not part of any standard IBM product 
 * and is provided to you solely for the purpose of assisting you in the 
 * development of your applications.  The code is provided 'AS IS', 
 * without warranty or condition of any kind.  IBM shall not be liable for any damages 
 * arising out of your use of the sample code, even if IBM has been 
 * advised of the possibility of such damages.
 *
 * Class Description:
 * This is an implementation class of GatewayUserExit Interface, and
 * provided as a sample program for AuditExits.
 * Creation date: (11/13/2001 9:47:57 AM)
 * @author: 
 */

import com.ibm.vgj.uibean.*;
import com.ibm.hpt.gateway.GatewayAccess;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

  
public class SampleUserExit implements GatewayUserExit
{
	/**
	 * Copyright information.
	 */
	public static final String COPYRIGHT = "(C) Copyright IBM Corp. 2000, 2001";

	/**
	 * Version information.
	 */
	public static final String VERSION = "4.5";

	VGJUIRecordBean 		sentBean			= null;
	VGJUIRecordBean 		receivedBean		= null;
	
	public Object			userState			= null;
	public String			errorMsg			= null;
	public int				errorRC				= 0;
	public String			myInfo				= null;
	public byte[]			bmyInfo				= null;	
	public String 			sessionId			= null;
	public String			userid				= null;
	public String			connectionId		= null;
	public String			programName			= null;

	//Control flags for the SampleUserExit
	public boolean			error				= false;
	public boolean			userDataRequest		= true;
	
/**
 * Insert the method's description here.
 * Creation date: (11/13/2001 9:51:03 AM)
 * @param bean com.ibm.vgj.uibean.VGJUIRecordBean
 * @param gatewayAccess com.ibm.hpt.gateway.GatewayAccess
 * @param request javax.servlet.http.HttpServletRequest
 * @param response javax.servlet.http.HttpServletResponse
 */
public void uirAuditExitIn(VGJUIRecordBean bean, GatewayAccess gatewayAccess, HttpServletRequest request, HttpServletResponse response) 
{
	String myInfo = "This is a sample user customizable class for Audit Exit";
	String userState = "This is user state for Audit Exit";
	HttpServletRequest httpRequest= request;
	HttpServletResponse httpResponse = response;
	
	//Bean will be null when a web application invoked from an entry page.
	if(bean != null)
		sentBean = bean;
	
	String	sessionId		= gatewayAccess.getSessionId();
	String	connectionId 	= gatewayAccess.getConnectionId();
	String	programName		= gatewayAccess.getProgramName();
	String	userid 			= gatewayAccess.getUserid();

	gatewayAccess.setUserState(userState);
	
	if(userDataRequest)
		gatewayAccess.setMyInfo(myInfo);

	//System.out.println statements will be written in a file (default: stdout.txt)
	//as it was configured in WebSphere
	System.out.println("sessionId in uirAuditExitIn: " + sessionId);
	System.out.println("connectionId in uirAuditExitIn: " + connectionId);
	System.out.println("programName in uirAuditExitIn: " + programName);	
	System.out.println("userid in uirAuditExitIn: " + userid);	
	System.out.println("userState in uirAuditExitIn: " + (String)gatewayAccess.getUserState());
	System.out.println("myInfo in uirAuditExitIn: " + gatewayAccess.getMyInfo());

	//gatewayAccess.trace statements will be written in Gateway's log file 
	//if hptErrorLog parameter points to a log file.
	gatewayAccess.trace("sessionId in uirAuditExitIn in VAGen log file: " + sessionId);
	gatewayAccess.trace("connectionId in uirAuditExitIn in VAGen log file: " + connectionId);		
	gatewayAccess.trace("programName in uirAuditExitIn in VAGen log file: " + programName);
	gatewayAccess.trace("userid in uirAuditExitIn in VAGen log file: " + userid);	
	gatewayAccess.trace("userState in uirAuditExitIn in VAGen log file: " + (String)gatewayAccess.getUserState());
	gatewayAccess.trace("myInfo in uirAuditExitIn in VAGen log file: " + gatewayAccess.getMyInfo());		
	
}
/**
 * Insert the method's description here.
 * Creation date: (11/13/2001 9:51:52 AM)
 * @param bean com.ibm.vgj.uibean.VGJUIRecordBean
 * @param gatewayAccess com.ibm.hpt.gateway.GatewayAccess
 * @param request javax.servlet.http.HttpServletRequest
 * @param response javax.servlet.http.HttpServletResponse
 */
public void uirAuditExitOut(VGJUIRecordBean bean, GatewayAccess gatewayAccess, HttpServletRequest request, HttpServletResponse response) 
{
	HttpServletRequest httpRequest = request;
	HttpServletResponse httpResponse = response;
	
	//Set the error message here for Gateway Servlet to display it on a browser.
	if(error)
	{
		gatewayAccess.setErrorRC(2);
		gatewayAccess.setErrorMessage("Error in the Sample user exit");
	}

	if(bean != null)
		receivedBean = bean;
	
	String	sessionId		= gatewayAccess.getSessionId();
	String	connectionId 	= gatewayAccess.getConnectionId();
	String	programName		= gatewayAccess.getProgramName();
	String	userid 			= gatewayAccess.getUserid();

	//System.out.println statements will be written in a file (default: stdout.txt)
	//as it was configured in WebSphere
	System.out.println("sessionId in uirAuditExitIn: " + sessionId);
	System.out.println("connectionId in uirAuditExitIn: " + connectionId);
	System.out.println("programName in uirAuditExitIn: " + programName);	
	System.out.println("userid in uirAuditExitIn: " + userid);	
	System.out.println("userState in uirAuditExitIn: " + (String)gatewayAccess.getUserState());
	System.out.println("myInfo in uirAuditExitIn: " + gatewayAccess.getMyInfo());

	//gatewayAccess.trace statements will be written in Gateway's log file 
	//if hptErrorLog parameter points to a log file.
	gatewayAccess.trace("sessionId in uirAuditExitIn in VAGen log file: " + sessionId);
	gatewayAccess.trace("connectionId in uirAuditExitIn in VAGen log file: " + connectionId);		
	gatewayAccess.trace("programName in uirAuditExitIn in VAGen log file: " + programName);
	gatewayAccess.trace("userid in uirAuditExitIn in VAGen log file: " + userid);	
	gatewayAccess.trace("userState in uirAuditExitIn in VAGen log file: " + (String)gatewayAccess.getUserState());
	gatewayAccess.trace("myInfo in uirAuditExitIn in VAGen log file: " + gatewayAccess.getMyInfo());		

}
}
